<?php

    require(dirname( __DIR__ ). '/../../wp-load.php');

    $apiToken = get_option('rapid_token');
    $function = $_POST["function"];
    $producto = $_POST["producto"];
    $orderId = $_POST["orderId"];
    $destino = $_POST["destino"];
    $recogida = $_POST["recogida"];

    switch ($function) {

        case "generarEnvioRapid":
                
            $return = '';
            $producto = $_POST["producto"];

            $data = array(
                "apiKey" => $apiToken,
                "producto" => $producto,
                "destino" => $destino,
                "recogida" => $recogida
            );

            $data_string = json_encode($data);
            $curl = curl_init();
            
            $url = "https://portal.rapidexpress.es/api/solicitarEnvio.php";

            curl_setopt_array($curl, array(
                CURLOPT_URL => $url,
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_ENCODING => "",
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_TIMEOUT => 30,
                CURLOPT_CUSTOMREQUEST => "POST",
                CURLOPT_POSTFIELDS => array("data"=>$data_string),
                CURLOPT_HTTPHEADER => array(
                    "cache-control: no-cache"
                ),
            ));
            
            $response = curl_exec($curl);
            $err = curl_error($curl);
            curl_close($curl);
            if ($err) {
                $return = "cURL Error #:" . $err;
            } else {

                $response = json_decode($response);

                if($response->result == 200 && $response->pedido != "" && $response->albaran != ""){
                    update_post_meta( $orderId, 'rapid_envio', $response->pedido );
                    update_post_meta( $orderId, 'rapid_albaran', $response->albaran );
                    //$order->save();
                } else {
                    $response = [ 'result' => 0, 'error' =>  $response ];
                }

            }
    
            echo json_encode($response);
            break;

        case "solicitarSoloAlbaran":
            
            $return = '';
            $data = array(
                "apiKey" => $apiToken,
                "producto" => $producto,
                "destino" => $destino
            );

            $data_string = json_encode($data);
            $curl = curl_init();
            
            $url = "https://portal.rapidexpress.es/api/solicitudSoloAlbaran.php";

            curl_setopt_array($curl, array(
                CURLOPT_URL => $url,
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_ENCODING => "",
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_TIMEOUT => 30,
                CURLOPT_CUSTOMREQUEST => "POST",
                CURLOPT_POSTFIELDS => array("data"=>$data_string),
                CURLOPT_HTTPHEADER => array(
                    "cache-control: no-cache"
                ),
            ));
            
            $response = curl_exec($curl);
            $err = curl_error($curl);
            curl_close($curl);
            if ($err) {
                $return = "cURL Error #:" . $err;
            } else {

                $response = json_decode($response);

                if($response->result == 200 && $response->pedido != "" && $response->albaran != ""){

                    update_post_meta( $orderId, 'rapid_envio', $response->pedido );
                    update_post_meta( $orderId, 'rapid_albaran', $response->albaran );
                    //$order->save();

                } else {
                    $response = [ 'result' => 0, 'error' =>  $response ];
                }
                
            }
    
            echo json_encode($response);
            break;

        case "obtenerAlbaran":
            
            $return = '';
            
            $order = $order = wc_get_order($orderId);
            $envio = $order->get_meta('rapid_envio');
        
            $data = array(
                            "apiKey" => $apiToken,
                            "envio" => $envio,
                        );
            $data_string = json_encode($data);
            $curl = curl_init();
            
            curl_setopt_array($curl, array(
                CURLOPT_URL => "https://portal.rapidexpress.es/api/obtenerAlbaran.php",
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_ENCODING => "",
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_TIMEOUT => 30,
                CURLOPT_SSL_VERIFYHOST => false,
                CURLOPT_SSL_VERIFYPEER => false,
                CURLOPT_CUSTOMREQUEST => "POST",
                CURLOPT_POSTFIELDS => array("data"=>$data_string),
                CURLOPT_HTTPHEADER => array(
                    "cache-control: no-cache"
                ),
            ));
            
            $response = curl_exec($curl);
            $err = curl_error($curl);
            curl_close($curl);
            if ($err) {
                $return = "cURL Error #:" . $err;
            } else {
                $return = $response;
                $response = json_decode($response, true);
				if($response['formato'] == 'PDF'){               
					$albaran = dirname(__DIR__)."/rapidexpress_wordpress/albaranes/".md5($envio).".pdf";
                    $fh2 = fopen($albaran, 'w') or die("can't open log file to append");
					fwrite($fh2, base64_decode($response['albaran']));
                    fclose($fh2);
                    $return = md5($envio);
				}
            }

            echo $return;
            break;
        
        case "solicitarServiciosRapid":

            $return = "";

            $data = array("apiKey" => $apiToken);
            $data_string = json_encode($data);
            $curl = curl_init();
            curl_setopt_array($curl, array(
                CURLOPT_URL => "https://portal.rapidexpress.es/api/servicios.php",
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_ENCODING => "",
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_TIMEOUT => 30,
                CURLOPT_CUSTOMREQUEST => "POST",
                CURLOPT_POSTFIELDS => array("data"=>$data_string),
                CURLOPT_HTTPHEADER => array(
                    "cache-control: no-cache"
                ),
            ));
            $response = curl_exec($curl);
            $err = curl_error($curl);
            curl_close($curl);
            if ($err) {
                $return = "cURL Error #:" . $err;
            } else {
                $return = $response;
            }
            
            echo $return;
            break;
    }